----------------------------------------------------------
--Point3 Manipulator
--Version 0.1
--Started: 12/25/00
--Edited:  12/25/00
--by Borislav Petrov [Boboland]
--http://gfxcentral.com/bobo/
----------------------------------------------------------

plugin simpleManipulator point3Manipulator
    name:"Point3"
    classID:#(0xeb3d8ecd, 0x769089fe)
    category:"Manipulators"
(
	
    parameters main rollout:paramRollout
    ( 
         -- The value of the slider
         P3value type:#point3  animatable:true  default:(Point3 0.0 0.0 0.0)
		 
         valueX      type:#float   animatable:true  ui:spnValueX  default: 0.0
         valueY      type:#float   animatable:true  ui:spnValueY  default: 0.0
         valueZ      type:#float   animatable:true  ui:spnValueZ  default: 0.0
         -- The min and max values the slider can take
         minValX       type:#float   animatable:true  ui:spnMinX      default: -100.0
         minValY       type:#float   animatable:true  ui:spnMinY      default: -100.0
         minValZ       type:#float   animatable:true  ui:spnMinZ      default: -100.0
		 
         maxValX       type:#float   animatable:true  ui:spnMaxX      default: 100.0
         maxValY       type:#float   animatable:true  ui:spnMaxY      default: 100.0
         maxValZ       type:#float   animatable:true  ui:spnMaxZ      default: 100.0

         defValX       type:#float   animatable:false  ui:spnDefX      default: 0.0
         defValY       type:#float   animatable:false  ui:spnDefY      default: 0.0
         defValZ       type:#float   animatable:false  ui:spnDefZ      default: 0.0
		 
         -- The slider position as a percentage of screen space
         xPos       type:#float   animatable:false ui:spnXPos   default: 0.0
         yPos       type:#float   animatable:false ui:spnYPos   default: 0.0
		 
		 size 		type:#float		animatble:false ui:spnSize	default: 35.0
         -- When the hide flag is true, the slider bar and value are not draw
         hide       type:#boolean animatable:false ui:checkHide default: false

         -- The display name of the slider
         sldName    type:#string  animatable:false              default: ""

		 
         snapToggleX type:#boolean animatable:false ui:checkSnapX default: true
         snapValX    type:#float   animatable:false  ui:spnSnapValX default: 1.0
         snapToggleY type:#boolean animatable:false ui:checkSnapY default: true
         snapValY    type:#float   animatable:false  ui:spnSnapValY default: 1.0
         snapToggleZ type:#boolean animatable:false ui:checkSnapZ default: true
         snapValZ    type:#float   animatable:false  ui:spnSnapValZ default: 1.0
		 

		 -- user colors
		 UserGreenColor		type:#color animatable:false	ui:UserGreenColor	default:(color 0 255 0)
		 UserYellowColor	type:#color animatable:false	ui:UserYellowColor	default:(color 255 255 0)
		 UserRedColor		type:#color animatable:false	ui:UserRedColor	default:(color 255 0 0)
		 UseCustomColors	type:#boolean animatable:false ui:UseCustomColors default: false
    )

    -- The rollout for the slider parameters
    rollout paramRollout "Point3 Manipulator"
    (
		Group "Point3 Parameters"
		(
		Label sliderName "Name:" across:2 align:#left
        Checkbox checkHide  "Hide"         checked:false align:#right
        Edittext nameEdit   ""        text:""	height:32 offset:[-5,0]
        Spinner  spnValueX   "X Value:"       range:[-1.0e30, 1.0e30, 0.0] 
        Spinner  spnValueY   "Y Value:"       range:[-1.0e30, 1.0e30, 0.0] 
        Spinner  spnValueZ   "Z Value:"       range:[-1.0e30, 1.0e30, 0.0] 


        Spinner  spnMinX     "Minimum X:"     range:[-1.0e30, 1.0e30, -100.0] 
        Spinner  spnMinY     "Minimum Y:"     range:[-1.0e30, 1.0e30, -100.0] 
        Spinner  spnMinZ     "Minimum Z:"     range:[-1.0e30, 1.0e30, -100.0] 
		
        Spinner  spnDefX     "Default X:"     range:[-1.0e30, 1.0e30, 0.0] 
        Spinner  spnDefY     "Default Y:"     range:[-1.0e30, 1.0e30, 0.0] 
        Spinner  spnDefZ     "Default Z:"     range:[-1.0e30, 1.0e30, 0.0] 

        Spinner  spnMaxX     "Maximum X:"     range:[0, 1.0e30, 100.0] 
        Spinner  spnMaxY     "Maximum Y:"     range:[0, 1.0e30, 100.0] 
        Spinner  spnMaxZ     "Maximum Z:"     range:[0, 1.0e30, 100.0] 
		
		)
		
		Group "Position and Size"
		(
        Spinner  spnXPos    "X Position:"  range:[0.0, 1.0, 0.0] scale:0.01
        Spinner  spnYPos    "Y Position:"  range:[0.0, 1.0, 0.0] scale:0.01
        Spinner  spnSize    "Size:"  range:[20.0, 200.0, 35.0] 
		)
		
		Group "Snaps"
		(
		button AllSnapsOn "All On" across:2 align:#left width:68 height:18
		button AllSnapsOff "All Off" align:#right width:68 height:18
		
        Checkbox checkSnapX  "Use X Snap" across:2 align:#left
        Spinner  spnSnapValX ""  range:[0.0, 10000.0, 1.0] align:#right fieldwidth:40

        Checkbox checkSnapY  "Use Y Snap" across:2 align:#left
        Spinner  spnSnapValY ""  range:[0.0, 10000.0, 1.0] align:#right fieldwidth:40

        Checkbox checkSnapZ  "Use Z Snap" across:2 align:#left
        Spinner  spnSnapValZ ""  range:[0.0, 10000.0, 1.0] align:#right fieldwidth:40
		)
		
		on AllSnapsOn pressed do snapToggleX = snapToggleY = snapToggleZ = true
		on AllSnapsOff pressed do snapToggleX = snapToggleY = snapToggleZ = false
		
		
		fn filter_sliders obj = ( FindItem (getPropNames obj) #UserGreenColor > 0 )	
		
		Group "Custom Colors"
		(
		checkbox UseCustomColors "Use" align:#left across:2
		ColorPicker UserGreenColor	"Active"		align:#right fieldwidth:40
		ColorPicker UserYellowColor	"Inactive"		align:#right fieldwidth:40
		ColorPicker UserRedColor	"Selected"		align:#right fieldwidth:40
		PickButton getColors "Acquire Colors From..." width:140 filter:filter_sliders
		)
		
		On getColors picked obj do
		(
		UserGreenColor.color = obj.UserGreenColor
		UserYellowColor.color = obj.UserYellowColor
		UserRedColor.color = obj.UserRedColor
		UseCustomColors.checked = obj.UseCustomColors
		)
		
        on nameEdit entered txt do 
        (
           sldName = txt
        )

        on paramRollout open do 
        (
           nameEdit.text = sldName
        )
    )

    -- This manipualtor manipulates itself
    on canManipulate target  return (classOf target) == point3Manipulator

    -- Creation mouse procedure
    tool create
    (
        on mousePoint click do
           case click of
           (
              1: 
              (
                -- Compute the percentage of of the mouse point in screen space
                this.xPos = viewPoint.x / gw.getWinSizeX()
                this.yPos = viewPoint.y / gw.getWinSizeY()

                #stop 
              )
           )

    )

    -- Create the manipulator gizmos.
    on updateGizmos do
    (
        -- Clear the current gizmo cache
        this.clearGizmos()

        -- If this is not a stand-alone manip, get values from the manip target
        if (target != undefined) then 
        (
           this.valueX      = target.valueX
           this.valueY      = target.valueY
           this.valueZ      = target.valueZ
           this.P3value 	= target.P3value
		   
           this.minValX     = target.minValX
           this.maxValX     = target.maxValX
           this.minValY     = target.minValY
           this.maxValY     = target.maxValY
           this.minValZ     = target.minValZ
           this.maxValZ     = target.maxValZ
		   
           this.defValX    = target.defValX
           this.defValY    = target.defValY
           this.defValZ    = target.defValZ
		   
           this.xPos       = target.xPos
           this.yPos       = target.yPos
	       this.hide       = target.hide
           this.sldName    = target.sldName
           this.size 	   = target.size
		   
		   this.snapToggleX = target.snapToggleX 
		   this.snapToggleY = target.snapToggleY 
		   this.snapToggleZ = target.snapToggleZ
		   this.snapValX    = target.snapValX    
		   this.snapValY    = target.snapValY    
		   this.snapValZ    = target.snapValZ
		   
		   if target.UseCustomColors then
		   (
		   UGreenColor   =  target.UserGreenColor / 255.0
		   URedColor =    target.UserRedColor / 255.0
		   )
		   else
		   (
    		UGreenColor   =  colorMan.getColor #manipulatorsActive   
		    URedColor =    colorMan.getColor #manipulatorsSelected
		   )
        ) 
        else
        (
		   if this.UseCustomColors then
			(
			UGreenColor   =  this.UserYellowColor / 255.0
		    URedColor =    this.UserRedColor / 255.0
			)
			else
			(
    		UGreenColor   =  colorMan.getColor #manipulatorsInactive
		    URedColor =    colorMan.getColor #manipulatorsSelected
			)
        )


        -- Compute the origin of the slider in screen space
        local x = xPos * gw.getWinSizeX()
        local y = yPos * gw.getWinSizeY()

        -- These flags are used for all the gizmos
        local flags = (gizmoUseScreenSpace + gizmoActiveViewportOnly)

        -- Gizmo 0
        -- This is the box that you use the move the manipulator
        
        this.addGizmoMarker #hollowBox [x+Size+10, y, 0.0] flags UGreenColor URedColor

		
        -- Gizmo 1
        -- This is the plus-sign used to toggle the hide flag
		
        this.addGizmoMarker #plusSign [x+Size+20,y,0] flags UGreenColor  URedColor

        -- Compute the text label
        if hide then 
		(
			str1 = sldName
			str2 = ""
		)
        else 
        (
            if sldName.count > 0 then 
			(
				str1 = sldName 
				str2 = "[" + (valueX as string) + ", " +(valueY as string)+", " +(valueZ as string)+"]"
			)
            else 
			(
				str1 = ""
				str2 = "[" + (valueX as string) + ", " +(valueY as string)+", " +(valueZ as string)+"]"
			)	
        )

        -- Gizmo 2 and 3
        -- The text with the name and value
        this.addGizmoText str1 [x+15+size, y-4 , 0.0] flags UGreenColor  URedColor
        this.addGizmoText str2 [x+15+size, y+20 , 0.0] flags UGreenColor  URedColor


        -- If the slider is hidden, don't draw any more
        if hide then return ""

        -- Draw Gizmo 4
        giz = manip.makeGizmoShape()
        giz.AddPoint [x-size,y-size,0]
        giz.AddPoint [x-size,y+size,0]
        giz.AddPoint [x+size,y+size,0]
        this.addGizmoShape giz flags UGreenColor  UGreenColor
		
        -- Gizmo 5
        giz = manip.makeGizmoShape()
        giz.AddPoint [x-size,y+size,0]
        giz.AddPoint [x+size*0.2,y-size*0.2,0]
        this.addGizmoShape giz flags UGreenColor  UGreenColor

        -- Gizmo 6
        -- X axis

		DeltaX = ((ValueX-MinValX)/(MaxValX-MinValX)*Size*2)
        giz = manip.makeGizmoShape()
        giz.AddPoint [x-size+DeltaX,y+size,0]
        giz.AddPoint [x-size+DeltaX-5,y+size+10,0]
        giz.AddPoint [x-size+DeltaX+5,y+size+10,0]
        giz.AddPoint [x-size+DeltaX,y+size,0]
        this.addGizmoShape giz flags [0.8,0.2,0.2] URedColor

        -- Gizmo 7
        -- Z axis
		DeltaZ = ((ValueZ-MinValZ)/(MaxValZ-MinValZ)*Size*2)
        giz = manip.makeGizmoShape()
        giz.AddPoint [x-size,y+size-DeltaZ,0] 
        giz.AddPoint [x-size-10,y+size-DeltaZ-5,0] 
        giz.AddPoint [x-size-10,y+size-DeltaZ+5,0] 
        giz.AddPoint [x-size,y+size-DeltaZ,0] 
        this.addGizmoShape giz flags [0.2,0.2,0.8] URedColor

		
        -- Gizmo 8
        -- Y axis
		DeltaY = ((ValueY-MinValY)/(MaxValY-MinValY)*Size*1.2)
        giz = manip.makeGizmoShape()
        giz.AddPoint [x-size+DeltaY,y+size-DeltaY,0]
        giz.AddPoint [x-size+DeltaY+10,y+size-DeltaY+3,0] 
        giz.AddPoint [x-size+DeltaY+3,y+size-DeltaY+10,0]
        giz.AddPoint [x-size+DeltaY,y+size-DeltaY,0]
        this.addGizmoShape giz flags [0.2,0.8,0.2] URedColor
		
		
        -- Gizmo 9
        -- The resize diamond
        this.addGizmoMarker #diamond [x+Size,y-Size,0] flags UGreenColor URedColor		


        -- Gizmo 10
		if DefValX >= MinValX and DefValX <= MaxValX then
		(
		DeltaX = ((DefValX-MinValX)/(MaxValX-MinValX)*Size*2)
        giz = manip.makeGizmoShape()
        giz.AddPoint [x-size+DeltaX,y+size,0]
        giz.AddPoint [x-size+DeltaX,y+size-10,0]
        this.addGizmoShape giz flags UGreenColor URedColor
		)
        -- Gizmo 11
		if DefValZ >= MinValZ and DefValZ <= MaxValZ then
		(
		DeltaZ = ((DefValZ-MinValZ)/(MaxValZ-MinValZ)*Size*2)
        giz = manip.makeGizmoShape()
        giz.AddPoint [x-size,y+size-DeltaZ,0] 
        giz.AddPoint [x-size+10,y+size-DeltaZ,0] 
        this.addGizmoShape giz flags UGreenColor URedColor
		)
        -- Gizmo 12
		if DefValY >= MinValY and DefValY <= MaxValY then
		(
		DeltaY = ((DefValY-MinValY)/(MaxValY-MinValY)*Size*1.2)
        giz = manip.makeGizmoShape()
        giz.AddPoint [x-size+DeltaY,y+size-DeltaY,0]
        giz.AddPoint [x-size+DeltaY-7,y+size-DeltaY-7,0]
        this.addGizmoShape giz flags UGreenColor URedColor
		)	
		
        -- Gizmo 13
        giz = manip.makeGizmoShape()
        giz.AddPoint [x-size,y+size,0]
        giz.AddPoint [x-size,y+size+10,0]
        this.addGizmoShape giz flags UGreenColor URedColor

        -- Gizmo 14
        giz = manip.makeGizmoShape()
        giz.AddPoint [x+size,y+size,0]
        giz.AddPoint [x+size,y+size+10,0]
        this.addGizmoShape giz flags UGreenColor URedColor
		
        -- Gizmo 15
        giz = manip.makeGizmoShape()
        giz.AddPoint [x-size,y+size,0]
        giz.AddPoint [x-size-10,y+size,0]
        this.addGizmoShape giz flags UGreenColor URedColor

        -- Gizmo 16
        giz = manip.makeGizmoShape()
        giz.AddPoint [x-size,y-size,0]
        giz.AddPoint [x-size-10,y-size,0]
        this.addGizmoShape giz flags UGreenColor URedColor		
		
		
        -- Gizmo 17
        giz = manip.makeGizmoShape()
        giz.AddPoint [x-size,y+size,0]
        giz.AddPoint [x-size-10,y+size+10,0]
        this.addGizmoShape giz flags UGreenColor URedColor

        -- Gizmo 18
        giz = manip.makeGizmoShape()
        giz.AddPoint [x+size*0.2,y-size*0.2,0]
        giz.AddPoint [x+size*0.2+7,y-size*0.2+7,0]
        this.addGizmoShape giz flags UGreenColor URedColor			
		
        -- return an empty string so no tool tip is displayed
        return ""
    )

    -- mouseMove is called on every mouse move when dragging the manip
    -- It needs to convert the mouse position 'm' into a new value for the slider
    on mouseMove m which do
    (
        local xSize = gw.getWinSizeX()
        local ySize = gw.getWinSizeY()
		
        -- Gizmo 0
        -- Set the slider postition
        if (which == 0)  then 
        (
            target.xPos = (m.x-Size-10) / xSize
            target.yPos = m.y / ySize
        ) 

        -- Gizmo 6
        -- Set the X value
        if (which == 6)  then 
        (
			NewValX = minValX+(m.x-((target.xPos*xSize)-Size))/Size/2*(MaxValX-MinValX)
            if (snapToggleX) then newValX = newValX - (mod newValX snapValX)
			
			if NewValX > maxValX then NewValX = maxValX 
			if NewValX < minValX then NewValX = minValX 
            target.ValueX = NewValX
			target.P3Value = Point3 target.ValueX target.ValueY target.ValueZ
        ) 


        if (which == 7)  then 
        (
			NewValZ = minValZ-(m.y-((target.yPos*ySize)+Size))/Size/2*(MaxValZ-MinValZ)
            if (snapToggleZ) then newValZ = newValZ - (mod newValZ snapValZ)
			
			if NewValZ > maxValZ then NewValZ = maxValZ 
			if NewValZ < minValZ then NewValZ = minValZ 
            target.ValueZ = NewValZ
			target.P3Value = Point3 target.ValueX target.ValueY target.ValueZ
        ) 


        if (which == 8)  then 
        (
			NewValY = minValY+(m.x-((target.xPos*xSize)-Size))/Size/1.2*(MaxValY-MinValY)
            if (snapToggleY) then newValY = newValY - (mod newValY snapValY)
			
			if NewValY > maxValY then NewValY = maxValY 
			if NewValY < minValY then NewValY = minValY 
            target.ValueY = NewValY
			target.P3Value = Point3 target.ValueX target.ValueY target.ValueZ
        ) 


        if (which == 9)  then 
        (
            -- Gizmo 6
            -- Set the size
			delta = (m.x-(target.xPos*xSize))
			if delta > 200 then delta = 200
			if delta < 20 then delta = 20
            target.size = delta
        ) 

		

	)
	
    on mouseDown m which do
    (
      -- Toggle the value of the "Hide" state
      if which == 1 then target.hide = not hide 
      if which == 10 then 
	  	(
		target.ValueX = target.DefValX
		target.P3Value = Point3 target.ValueX target.ValueY target.ValueZ
		)
      if which == 11 then 
	  	(
		target.ValueZ = target.DefValZ
		target.P3Value = Point3 target.ValueX target.ValueY target.ValueZ
		)
      if which == 12 then 
	  	(
		target.ValueY = target.DefValY
		target.P3Value = Point3 target.ValueX target.ValueY target.ValueZ
		)

      if which == 13 then 
	  	(
		target.ValueX = target.MinValX
		target.P3Value = Point3 target.ValueX target.ValueY target.ValueZ
		)
      if which == 14 then 
	  	(
		target.ValueX = target.MaxValX
		target.P3Value = Point3 target.ValueX target.ValueY target.ValueZ
		)		

      if which == 15 then 
	  	(
		target.ValueZ = target.MinValZ
		target.P3Value = Point3 target.ValueX target.ValueY target.ValueZ
		)
      if which == 16 then 
	  	(
		target.ValueZ = target.MaxValZ
		target.P3Value = Point3 target.ValueX target.ValueY target.ValueZ
		)		  
		
      if which == 17 then 
	  	(
		target.ValueY = target.MinValY
		target.P3Value = Point3 target.ValueX target.ValueY target.ValueZ
		)
      if which == 18 then 
	  	(
		target.ValueY = target.MaxValY
		target.P3Value = Point3 target.ValueX target.ValueY target.ValueZ
		)				
    )
	
)
